web/router.ex
defmodule BachelorThesis.Router do
  use BachelorThesis.Web, :router

  pipeline :browser do
    plug :accepts, ["html"]
    plug :fetch_session
    plug :fetch_flash
    plug :protect_from_forgery
    plug :put_secure_browser_headers
  end

  pipeline :authentication do
    plug BachelorThesis.Plug.Authenticate
  end

  pipeline :api do
    plug :accepts, ["json"]
  end

  scope "/", BachelorThesis do
    pipe_through :browser # Use the default browser stack

    get "/", PageController, :index

    resources "/users", UserController, only: [:create, :new]

    # login session
    post "/login", SessionController, :create
    delete "/logout", SessionController, :delete

    # pair up device by token
    get "/pairUpDevice/:token", DeviceController, :pairUpDeviceByToken
    get "/pairUpSmartDevice/:token", SmartDeviceController, :pairUpSmartDeviceByToken

    # control device by smart device
    get "/setDeviceAction/:device_token/:smart_device_token/:interface_type_shortcut/:value", DeviceActionController, :setAction
    # device info
    get "/setDeviceValue/:device_token/:interface_type_shortcut/:value", DeviceValueController, :setValue
    # confirm device action
    get "/confirmAction/:device_token/:action_id", DeviceActionController, :confirmAction
    # device info
    get "/getDeviceValue/:device_token", DeviceValueController, :getValue
    get "/getDeviceAction/:device_token", DeviceActionController, :getAction
    end

  scope "/", BachelorThesis do
    pipe_through [:browser, :authentication]

    resources "/users", UserController, except: [:create, :new, :index] do
      # smart_devices
      resources "/smart_devices", SmartDeviceController
      post "/smart_device/:smart_device_id/pair", SmartDeviceController, :pairDevice
      delete "/smart_device/:smart_device_id/delete/:id", SmartDeviceController, :deletePairDevice
      post "/smart_device/:smart_device_id/unpairSmartDevice/", SmartDeviceController, :unpairSmartDevice
      post "/smart_device/:smart_device_id/activateSmartDevice/:action", SmartDeviceController, :activateSmartDevice

      # devices
      resources "/devices", DeviceController
      post "/device/:device_id/pair", DeviceController, :pairDevice
      delete "/device/:device_id/delete/:id", DeviceController, :deletePairDevice
      post "/device/:device_id/unpairDevice/", DeviceController, :unpairDevice
      post "/device/:device_id/activateDevice/:action", DeviceController, :activateDevice
    end
  end

  # Other scopes may use custom stacks.
  # scope "/api", BachelorThesis do
  #   pipe_through :api
  # end

  scope "/graphql" do
    pipe_through :api

    # Welcome API
    get "/api", BachelorThesis.PageController, :api
    post "/api", BachelorThesis.PageController, :api_post

    get "/device", GraphQL.Plug, schema: {GraphQL.Schema.DeviceSchema, :schema}
    post "/device", GraphQL.Plug, schema: {GraphQL.Schema.DeviceSchema, :schema}
  end
end

web/views/layout_view.ex
defmodule BachelorThesis.LayoutView do
  use BachelorThesis.Web, :view
end

web/templates/layout/app.html.eex
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="description" content="">
    <meta name="author" content="">

    <title>Hello BachelorThesis!</title>
    <link rel="stylesheet" href="<%= static_path(@conn, "/css/app.css") %>">
  </head>

  <body>
    <div class="container">
      <header class="header">
        <nav role="navigation">
          <ul class="nav nav-pills pull-right">
            <%= if logged_in?(@conn) do %>
            <li>
              <% current_user = current_user(@conn) %>
              <label><%= current_user.firstName <> " " <> current_user.lastName %></label>
              <%= link "Logout", to: session_path(@conn, :delete), method: :delete %>
            </li>
            <%= end %>
            <li><%= link "Home", to: page_path(@conn, :index) %></li>
          </ul>
        </nav>
        <span>
          <h1>Application of smart watches for remote devices control</h1>
        </span>
      </header>

      <p class="alert alert-info" role="alert"><%= get_flash(@conn, :info) %></p>
      <p class="alert alert-danger" role="alert"><%= get_flash(@conn, :error) %></p>

      <main role="main">
        <%= render @view_module, @view_template, assigns %>
      </main>

    </div> <!-- /container -->
    <script src="<%= static_path(@conn, "/js/app.js") %>"></script>
  </body>
</html>